#!/bin/sh

#########################
# The command line help #
#########################
display_help() {
	echo "Usage: $0 <Aspen number 1-2> <SPI_flash_image_binary>" >&2
	echo
	exit 1
}

# Check if image file is defined
if [ -z "$2" ]
then
	echo "### No Image file defined ###"
	echo
	display_help
fi

# Check if image file exists
if [ ! -e $2 ]
then
	echo "### Image file doesn't exist ###"
	echo
	display_help
fi

case $1 in
    1 | 2)
	# reset Maple $1
	#echo "Put Aspen $1 in a reset state"
	./.Maple$1_reset.sh
	sleep 0.1
	#echo "Connect CPU to SPI Flash chip $1"
	echo $1 > /sys/module/it_fpga/parameters/cpu_to_spiFlash_connect
	sleep 0.1
	#./.display_fpga_Maple_status.sh
	# reset & release reset SPI FLash $1
	#echo "Set SPI Flash $1 in read mode by short reset pulse"
	echo 1 > /sys/module/it_fpga/parameters/spiFlash$1_Reset
	sleep 0.1
	echo 0 > /sys/module/it_fpga/parameters/spiFlash$1_Reset
	sleep 0.1
	# Erase SPI Flash $1
	#echo "Erase SPI Flash $1 (should take about 2 minutes if OK)"
	sleep 0.1
	#./.SPI_Flash_Erase.sh $1
	#if [ $? -eq 0 ]
	#then
		sleep 0.1
		# reset & release reset SPI FLash $1
		#echo "Set SPI Flash $1 in read mode by short reset pulse"
		echo 1 > /sys/module/it_fpga/parameters/spiFlash$1_Reset
		sleep 0.1
		echo 0 > /sys/module/it_fpga/parameters/spiFlash$1_Reset
		sleep 0.1
		echo "Write SPI Flash $1 with file '$2'"
		./.SPI_Flash_Program.sh $1 $2
		if [ $? -ne 0 ]
		then
			echo "#### Program Error ####"
		fi
	#!!!fi
	#echo "Connect Maple Controllers to their SPI Flash chips"
	echo 0 > /sys/module/it_fpga/parameters/cpu_to_spiFlash_connect
	sleep 0.1
	#./.display_fpga_Maple_status.sh
	# reset & release reset SPI FLash $1
	#echo "Set SPI Flash $1 in read mode by short reset pulse"
	echo 1 > /sys/module/it_fpga/parameters/spiFlash$1_Reset
	sleep 0.1
	echo 0 > /sys/module/it_fpga/parameters/spiFlash$1_Reset
	sleep 0.1
    ;;
    *)
	display_help
    ;;
esac


