#! /bin/bash
export  LD_LIBRARY_PATH=LD_LIBRARY_PATH:/opt/si2000/neroot/active/maple/lib
#echo "SPK" > /tmp/get_board_id
cd /opt/si2000/neroot/active/maple/bin
./cleanup.sh

# These files are mounted using tmpfs, so they will be deleted upon reboot
LOCK_DIR_INIT=/tmp/bcm68620_svk_init
FILE_INIT_DONE="$LOCK_DIR_INIT/done"
DEV_MGMT_INIT_DONE=/tmp/root_dev_mgmt_init_done
DEV_MGMT_INIT_TIME=5

EXAMPLE_USER_APPL_ARGS=""
COOP_DBA="n"
#SVK4_P100_IDENT_FILE="/etc/svk4"
DEV_MGMT_DAEMON_ARGS=""

MGMT_HOST=`uname -m`

#BOARD_TYPE=""

function RMMOD
{
    if [ ! -z "`lsmod | grep -m 1 $1 | awk {'print $1'}`" ]; then
        echo "removing $1"
        rmmod $1
    fi
}

function remove_switch_drivers
{
    RMMOD linux_user_bde
    # don't remove this sleep
    sleep 1
    RMMOD linux_kernel_bde
    RMMOD linux_uk_proxy
}

function remove_mac_drivers
{
    RMMOD coop_dba_example
    RMMOD coop_dba
    RMMOD devmem
    RMMOD nltr
    RMMOD pcie_proxy
    # don't remove this sleep
    sleep 2
    RMMOD fld_linux
    RMMOD os_linux
    RMMOD ll_pcie
    RMMOD i2c_devs
}

# If a 'topology_config.ini' file exists, use it. If topology_config.ini is a symlink or not present,
# set it based on the command line parameter. If no command line parameter given and topology_config.ini
# is either a file or symlink, use it; otherwise, it is an error.
# $1 - SVK type
#function setup_topology_config
#{
#    _SVK_TYPE=$1
#
#    # If the topology_config.ini is a file (not symlink), we use it regardless of SVK_TYPE
#    test -e topology_config.ini && test ! -L topology_config.ini && return
#
#    # If we got here, then the topology_config.ini is either a symlink or not present
#    if test -z $_SVK_TYPE; then
#        # SVK type not given, see if we can use topology_config.ini that exists
#        if test ! -e topology_config.ini; then
#            echo "ERROR: Did not specify an SVK type for topology and topology_config.ini does not exist"
#            exit 1
#        fi
#    else
#        # SVK type was given
#        _SVK_TOPOLOGY_CONFIG_FILE=topology_config_${_SVK_TYPE}.ini
#
#        if test -e $_SVK_TOPOLOGY_CONFIG_FILE; then
#            # SVK specific file is present so set a symlink
#            ln -sf $_SVK_TOPOLOGY_CONFIG_FILE topology_config.ini
#        else
#            # Specified SVK file was not found, this is an error
#            echo "ERROR: Specified SVK type does not have the expected topology file : $_SVK_TOPOLOGY_CONFIG_FILE"
#            exit 1
#        fi
#    fi
#}

function stop_processes
{
    if [ ! -z "$(ps -ef | grep dev_mgmt_daemon | grep -v grep | awk '{print $4}')" ]; then
        echo "Stopping the dev_mgmt_daemon"
        pkill -f -9 dev_mgmt_daemon
    fi
    rm -fr $DEV_MGMT_INIT_DONE

    if [ ! -z "$(ps -ef | grep bcm_maple_daemon | grep -v grep | awk '{print $4}')" ]; then
        echo "Stopping the bcm_maple_daemon"
        pkill -f -9 bcm_maple_daemon
    fi
}

# this is a 'clean aware' mknod.  If 'clean', remove the existing node before installing it
function MKNOD
{
    if [ $IS_CLEAN == "y" ]; then
        rm -f $1
    fi
    if [ ! -e $1 ]; then
        mknod $@
    fi
}

# Small helper function for probing i2c clients/slaves.
#function probe_dev
#{
#    2>/dev/null echo bcmolt_i2c 0x$1 > /sys/bus/i2c/devices/i2c-0/new_device
#}

# This function inserts i2c_devs kernel module.
# During the module initialization the "base" i2c slaves/clients are created (I2C switches and FPGA).
# All other i2c slave devices are created in the function configure_i2c.
# If the board is SVK#4-p100 we have to state it in the module's input parameter.
# (This is needed since access to FPGA is differ in SVK4_p100 boards.)
#function install_i2c_module
#{
#    source ./i2c_addrs.sh
#    if [ -f "$SVK4_P100_IDENT_FILE" ]; then
#      echo "Inserting I2C module for SVK#4 p100 board"
#      insmod i2c_devs.ko svk4_p100_board=1
#    else
#      echo "Inserting I2C module"
#      insmod i2c_devs.ko
#    fi
#
#    # Probe FPGA client. In some kernels (like wrx) it is not created during the above insmod
#    # and has to be instantiated via sysfs.
#    # Suppress warnings in case the fpga client already created in insmod.
#    dmesg -n 1
#    probe_dev $FPGA_I2C_ADDR
#    dmesg -n 7
#
#    MKNOD /dev/bcmolt_i2c c `cat /sys/module/i2c_devs/parameters/bcmolt_i2c_chrdev_major` 0
#}

# Instantiate all I2C devices according to board type except the "base" devices
# that were already created during i2c_devs.ko module initialization
#function configure_i2c
#{
#    BOARD_PON_PLATFORM=`echo -n $BOARD_TYPE | cut -d: -f1`
#    [ -z "$BOARD_PON_PLATFORM" ] && echo "Failed to get board PON platform type from FPGA" && exit 1
#
#    echo "Board PON platform: "$BOARD_PON_PLATFORM
#
#    # Suppress error warnings in case device cannot be probed because it is inexistent or already exist
#    dmesg -n 1
#    if [ "$BOARD_PON_PLATFORM" == "maple" ] ; then
#        probe_dev $SFP_I2C_ADDR1
#        probe_dev $SFP_I2C_ADDR2
#        probe_dev $PON_DPLL_I2C_ADDR
#        probe_dev $PM_DPLL_I2C_ADDR
#        probe_dev $CXP_T_I2C_ADDR
#        probe_dev $CXP_R_I2C_ADDR
#        probe_dev $PCIE_SW_I2C_ADDR
#    elif [ "$BOARD_PON_PLATFORM" == "aspen" ] ; then
#        probe_dev $PON_DPLL_I2C_ADDR
#        probe_dev $PCIE_SW_NEW_I2C_ADDR
#        probe_dev $PCIE_CLK_GEN_I2C_ADDR
#        probe_dev $THERM_SENS_I2C_ADDR
#        probe_dev $FAN_CTRL_I2C_ADDR
#        probe_dev $A2D_CONV_I2C_ADDR
#        probe_dev $PWR_SEQ_I2C_ADDR
#        probe_dev $LINKS_I2C_ADDR
#        probe_dev $SFP_I2C_ADDR2
#        probe_dev $SFP_PAGE_B0_ADDR
#        probe_dev $SFP_PAGE_B2_ADDR
#    else
#        echo "Error: Unknown board PON platform: "$BOARD_PON_PLATFORM && exit 1
#    fi
#    dmesg -n 8
#
#    sleep 1
#}

function configure_qumran_nodes
{
    # Create the nodes needed by the Qumran switch
    MKNOD /dev/linux-user-bde c 126 0
    MKNOD /dev/linux-kernel-bde c 127 0
    MKNOD /dev/linux-uk-proxy c 125 0
}

MANIFEST_FILE=package.manifest

function check_directory_against_manifest
{
    echo "Validating file presence against manifest..."
    if [ -f $MANIFEST_FILE ]; then
        MISSING_FILES=
        NUM_FILES=0
        while IFS= read -r file_line
        do
            # skip any comment or blank lines
            if [ "${file_line:0:1}" == "#" ] || [ "${file_line:0:1}" == "" ]; then
                continue
            fi

            NUM_FILES=$((NUM_FILES+=1))

            # if any files are missing, then add them to the list to report to the user
            if [ ! -f $file_line ]; then
                if [ -z "$MISSING_FILES" ]; then
                    DELIMIT=""
                else
                    DELIMIT=","
                fi
                MISSING_FILES="$MISSING_FILES$DELIMIT$file_line"
            fi

        done <"$MANIFEST_FILE"
        if [ ! -z "$MISSING_FILES" ]; then
            echo "File check failed: the following file(s) are missing ($NUM_FILES file names found in manifest):"
            echo $MISSING_FILES
            exit 1
        else
            echo "File check complete and successful ($NUM_FILES file names found in manifest matched those present)"
        fi
    else
        echo "!WARNING: no \"$MANIFEST_FILE\" file found"
        echo
    fi
}

# Configure the config.bcm file for the desired port rates
function set_config_bcm ()
{
    PASSTHROUGH=$1
    NNI_RATE=$2
    INNI_RATE=$3
    BASE_FILE=config.bcm
    USE_FILE=config.bcm.in_use
    GOLDEN_FILE=${BASE_FILE}.passthrough

    # We can't continue without this
    if [ ! -e ${GOLDEN_FILE} ]; then
        echo "Cannot setup custom QAX config without ${GOLDEN_FILE}"
        return
    fi

    # If we asked for a specific configuration, then it is OK to remove this file`
    test -e ${USE_FILE} && rm ${USE_FILE}
    touch ${USE_FILE}

    # We can do this; it is a link
    test -e ${BASE_FILE} && rm ${BASE_FILE}

    if [ ${PASSTHROUGH} == "y" ]; then
        # All passthrough mode require pon_application support to be disabled
        echo "Disabling PON Application in QAX"
        grep "pon_application_support_enabled" ${GOLDEN_FILE} > ${USE_FILE}
    fi

    case $NNI_RATE in
        10G)
            echo "Setting NNI rate to 10G"
        # Default
        ;;

        25G)
            echo "Setting NNI rate to 25G"
            egrep "port_init_speed_1[34][0-9]=25000" ${GOLDEN_FILE} | sed 's/#//' >> ${USE_FILE}
        ;;

        *)
            echo "Unsupported NNI RATE"
            exit
            ;;
    esac

    case $INNI_RATE in
        10G)
            echo "Setting INNI rate to 10G"
        # Default
        ;;

        12G)
            echo "Setting INNI rate to 12G"
            egrep "port_init_speed_[0-9]=12000" ${GOLDEN_FILE} | sed 's/#//' >> ${USE_FILE}
        ;;

        25G)
            echo "Setting INNI rate to 25G"
            egrep "port_init_speed_[0-9]=25000" ${GOLDEN_FILE} | sed 's/#//' >> ${USE_FILE}
        ;;

        *)
            echo "Unsupported INNI RATE"
            exit
            ;;
    esac

    # Setup ENV var so that the CSG SDK uses these values from this file.
    BCM_CONFIG_FILE=${USE_FILE}; export BCM_CONFIG_FILE
}

IS_3BOX="n"
IS_STARTING="y"
IS_DEBUG="n"
IS_MACONLY="n"
IS_PCIE_SUPPORTED="y"
IS_PASSTHROUGH="n"
INNI_RATE=10G
NNI_RATE=10G
INSTALL_SW_DBG_TOOLS="n"
IS_CLEAN="y"
IS_CLEAN_ISSU_DBS="n"
IS_CAPTURE_LOGS="n"
USE_MSI="y"
#if test ! -f ll_pcie.ko; then
#   echo "PCIe support drivers are missing. PCIE support disabled.."
#   IS_PCIE_SUPPORTED="n"
#fi

while [ $# -ne 0 ]; do
    case "$1" in
    -debug)
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS -d"
        IS_DEBUG="y"
        ;;
    -inband)
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS -inband"
        shift
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS $1"
        ;;
    -nopcie)
        IS_PCIE_SUPPORTED="n"
                echo "PCIE boot support disabled"
        ;;
    -coop_dba)
        COOP_DBA="y"
        ;;
    -3box)
        IS_3BOX="y"
        EXAMPLE_USER_APPL_ARGS="$EXAMPLE_USER_APPL_ARGS -3box"
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS -distr_devm_dev"
        ;;
    -app_udp_port)
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS -app_udp_port"
        shift
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS $1"
        ;;
    -mac) #this is only needed for SVK4 in mac-only mode (no BAL). In all other cases it does nothing
        IS_MACONLY="y"
        ;;
    -noclean)
        IS_CLEAN="n"
        ;;
    -clean)  # this is needed only to prevent this deprecated command from interfering with example_usr_appl startup
        IS_CLEAN="y"
        ;;
    -clean_issu_dbs)  # this is used to delete issu db files for BAL & switch SDK
        IS_CLEAN_ISSU_DBS="y"
        ;;
    -stop)
        IS_STARTING="n"
        ;;
    -check)
        check_directory_against_manifest
        exit 0
        ;;
    -disable_daemon_cli)
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS -no_cli"
        ;;
    -passthrough)
        IS_PASSTHROUGH="y"
        ;;
    -inni)
        shift
        INNI_RATE=$1
        ;;
    -nni)
        shift
        NNI_RATE=$1
        ;;
    -ps_bal_enable)
        EXAMPLE_USER_APPL_ARGS="$EXAMPLE_USER_APPL_ARGS -ps_bal_enable"
        ;;
    -issu)
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS -issu"
        DEV_MGMT_INIT_TIME=60
        ;;
    -config_log)
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS -config_log"
        shift
        DEV_MGMT_DAEMON_ARGS="$DEV_MGMT_DAEMON_ARGS $1 $2"
        ;;
    -install_sw_dbg)
        shift
        INSTALL_SW_DBG_TOOLS="y"
        ;;
	-capture_logs)
        shift
        IS_CAPTURE_LOGS="y"
        ;;
    *)
        EXAMPLE_USER_APPL_ARGS="$EXAMPLE_USER_APPL_ARGS $1"
        ;;
    esac
    shift
done

if [ $INSTALL_SW_DBG_TOOLS == "y" ]; then
    if [ ! -f dbg-tools.tgz ]; then
        echo "Can't find dbg-tools.tgz, so can't perform installation"
    else
        if [ ! -d $DPP_DB_PATH ]; then
             mkdir -p $DPP_DB_PATH
        fi

        cp dbg-tools.tgz $DPP_DB_PATH
        cd $DPP_DB_PATH && tar xzf dbg-tools.tgz && echo "installation success"
        cd /opt/bcm68620
    fi
    exit 0
fi

# 'clean' stops the dev_mgmt_daemon and clears the flag for device and module installation
if [ $IS_CLEAN == "y" ]; then
    stop_processes

    echo "Cleaning up the system"
    rm -fr $LOCK_DIR_INIT

    sleep 1

    remove_switch_drivers
    remove_mac_drivers
fi

if [ $IS_CLEAN_ISSU_DBS == "y" ]; then

    echo "Removing ISSU DB files for BAL and Switch SDK"
    rm -f issu_db_bal.db
    rm -f issu_db_switch.db
fi

# this takes care of stop case
if [ $IS_STARTING == "n" ]; then
    stop_processes
    echo "finished"
    exit 0
fi

# check the directory file names against the package manifest file
check_directory_against_manifest

# minimal option validation
if [ $IS_3BOX == "y" ] && [ ! -z "`echo $EXAMPLE_USER_APPL_ARGS | grep "\-proxy"`" ]; then
    echo "ERROR: -proxy and -3box options are incompatible"
    exit 1
fi

# Check if the initialization steps (installing kernel modules, etc) have already been done.
# If not, start the initialization process.
if mkdir "$LOCK_DIR_INIT" 2>/dev/null; then
    trap "rmdir \"$LOCK_DIR_INIT\"" EXIT
    echo "Initializing BCM686xx SDK..."

    # configure the nodes required for the Qumran SDK to access the device
    configure_qumran_nodes

    # Install i2c module with the base i2c slaves (i2c switches and FPGA)
    #install_i2c_module

    # Now (when FPGA is accessible via i2v interface) we can get board type info
    # (the string looks as "platform-type:svk-id", for ex, "maple:svk1" or "aspen:svk2")
    #BOARD_TYPE=$(cat /tmp/get_board_id)
    #DEVICE_TYPE=`echo -n $BOARD_TYPE | cut -d: -f1`

    #[ $? -ne 0 ] && echo "Could not get the board type from the FPGA" && exit 1
    #echo "Board type: "$BOARD_TYPE  "MAC DEVICE TYPE: "$DEVICE_TYPE

    # Create all other i2c slaves according to the board platform type
    #configure_i2c

    if [ $IS_PCIE_SUPPORTED != "n" ]; then
        LL_PCIE_PARMS=""
        if [ $USE_MSI != "n" ]; then
            LL_PCIE_PARMS="$LL_PCIE_PARMS bcm686xx_use_msi=1"
        fi
        sleep 1
        modprobe os_linux
        modprobe fld_linux
        echo "Device Management Daemon over PCIE"
        modprobe devmem
        modprobe pcie_proxy
        modprobe nltr
        modprobe ll_pcie
        DEVMEM_MAJOR=`cat /sys/module/devmem/parameters/bcmolt_devmem_chrdev_major`
        MKNOD /dev/bcmolt_devmem_sram0 c $DEVMEM_MAJOR 0
        MKNOD /dev/bcmolt_devmem_ddr0 c $DEVMEM_MAJOR 1
        MKNOD /dev/bcmolt_devmem_regs0 c $DEVMEM_MAJOR 2
        DEVMEM_MAJOR=`expr $DEVMEM_MAJOR + 1`
        MKNOD /dev/bcmolt_devmem_sram1 c $DEVMEM_MAJOR 0
        MKNOD /dev/bcmolt_devmem_ddr1 c $DEVMEM_MAJOR 1
        MKNOD /dev/bcmolt_devmem_regs1 c $DEVMEM_MAJOR 2
        PCIE_PROXY_MAJOR=`cat /sys/module/pcie_proxy/parameters/chrdev_major`
        MKNOD /dev/bcmolt_pcie_proxy c $PCIE_PROXY_MAJOR 0
    fi

    if [ "$COOP_DBA" != "n" ]; then
        insmod coop_dba.ko
        insmod coop_dba_example.ko
        sleep 1
    fi

    rm -f /dev/bcm_log
    if [ "$COOP_DBA" != "n" ]; then
        MKNOD /dev/coop_dba c `cat /sys/module/coop_dba/parameters/coop_dba_chrdev_major` 0
        MKNOD /dev/coop_dba_example c `cat /sys/module/coop_dba_example/parameters/coop_dba_example_chrdev_major` 0
    fi

    touch "$FILE_INIT_DONE"
    trap - EXIT
else
    if [ -f "$FILE_INIT_DONE" ]; then
        echo "Skipped BCM68620 SVK initialization since it has already been done"
    else
        echo "Waiting for SVK initialization to complete..."
        while [ ! -f "$FILE_INIT_DONE" ]; do
            sleep 1
        done
    fi

    # The i2c Module already installed, just get board type
    #BOARD_TYPE=$(./board_id_get)

    touch "$FILE_INIT_DONE"
    trap - EXIT
fi

# Now setup the topology_config file based on the board ID returned from the FPGA
# If this is an SVK4 p100, we can find that out from SVK4_P100_IDENT_FILE.  This cannot be done
# until the kernel modules (above) have been installed
#if [ -e $SVK4_P100_IDENT_FILE ]; then
#    if [ $IS_MACONLY == "n" ]; then
#        setup_topology_config svk4
#    else
#        setup_topology_config svk4_mac
#    fi
#else
#    SVK_TYPE=`echo -n $BOARD_TYPE | cut -d: -f2`
#    if [ $IS_MACONLY == "y" ] && [ $BOARD_TYPE == "maple:svk4"]; then
#        setup_topology_config svk4_mac
#   else
#        setup_topology_config $SVK_TYPE
#    fi
#fi

#echo "Topology setup complete"

# If config.bcm exists as a file, use it as is.  Otherwise
#
#  1.  If passthrough was specified, setup a file with the passthrough values - and the rates.  The rates
#      can be specified on the command line, or default to 10G for both NNI and INNI.
#  2.  If pass thought was not specified, just setup a file with the rates.
#
# Then set the env variable so that we use the file just created.
#
# Under no circumstances do we do anything if config.bcm exists as a regular file!!!
#
BOARD_PON_PLATFORM="maple"
if [ "$BOARD_PON_PLATFORM" == "aspen" ] ; then
    if [ ! -e config.bcm ]  ||  [ -L config.bcm ]; then
        set_config_bcm ${IS_PASSTHROUGH} ${NNI_RATE} ${INNI_RATE}
    else
    echo "==============================================================="
    echo " !WARNING: Using custom config.bcm"
    echo "==============================================================="
    fi
fi

if [ -f $DEV_MGMT_INIT_DONE ] && [ ! -z $(ps -e| grep dev_mgmt_daemon | grep -v grep  | awk '{print $4}') ] && [ $IS_DEBUG == "n" ]; then
    echo "==============================================================="
    echo " !WARNING: Using the dev_mgmt_daemon which was already running "
    echo "==============================================================="
else
    stop_processes

    echo "Launching the dev_mgmt_daemon  with options \"$DEV_MGMT_DAEMON_ARGS\""
    /opt/si2000/neroot/active/maple/bin/dev_mgmt_daemon $DEV_MGMT_DAEMON_ARGS

    if [ $IS_DEBUG == "n" ]; then
        echo "Waiting for the dev_mgmt_daemon init completion..."
        max_dev_mgr_start_time=$DEV_MGMT_INIT_TIME
        while test ! -f $DEV_MGMT_INIT_DONE; do
            sleep 1
            max_dev_mgr_start_time=$((max_dev_mgr_start_time-1))

            if [ $max_dev_mgr_start_time -eq 0 ]; then
                echo "dev_mgmt_daemon has failed to start, exiting"
                exit 1
            fi
        done
        echo "===================================="
        echo "==== dev_mgmt_daemon is running ===="
        echo "===================================="
    else
        echo "dev_mgmt_daemon terminated with status $?"
    fi
fi

if [ $IS_DEBUG == "n" ]; then
    echo "Launching bcm_maple_daemon with \"$EXAMPLE_USER_APPL_ARGS\""
    /opt/si2000/neroot/active/maple/bin/bcm_maple_daemon $EXAMPLE_USER_APPL_ARGS
fi

if [ $IS_CAPTURE_LOGS == "y" ]; then
	#Cat serial ports to log.
	stty -echo -icanon  -F /dev/ttyAMA3 115200
	stty -echo -icanon  -F /dev/ttyAMA4 115200
	sleep 1
	cat /dev/ttyAMA3 >> /var/log/aspen_console_ama3.log &
	cat /dev/ttyAMA4 >> /var/log/aspen_console_ama4.log &
	cat /tmp/root_dev_mgmt_cli.output >> /var/log/dev_mgmt.log &
fi
